// Symbol types
#define TYPE_OP0    0
#define TYPE_OP1D   1
#define TYPE_OP2    2
#define TYPE_OP1S   3
#define TYPE_BYTE   4
#define TYPE_LONG   5
#define TYPE_ORG    6
#define TYPE_RES    7
#define TYPE_CALL   8
#define TYPE_OP1DN  9
#define TYPE_OPREP  10
#define TYPE_OP2DB  11
#define TYPE_OP2P   13
#define TYPE_OP1DP  14
#define TYPE_WORD   15
#define TYPE_IF     16
#define TYPE_CON    17
#define TYPE_WX     18
#define TYPE_NX     19
#define TYPE_ADDR   20
#define TYPE_FIT    21
#define TYPE_OP2A   22
#define TYPE_OP2B   23
#define TYPE_OP2C   24
#define TYPE_OP1A   25
#define TYPE_OP1B   26
#define TYPE_OP1C   27
#define TYPE_OP2D   28
#define TYPE_OP2E   29
#define TYPE_FILE   30

#define MAX_SYMBOLS 1000

// Symbol table entry
typedef struct SymbolS {
    unsigned int value;
    unsigned int value2;
    int type;
    char name[31];
} SymbolT;

int FindSymbol(char *symbol);
void ReadSymbolTable(void);
void AddSymbol(char *symbol, int value, int type);
void AddSymbol2(char *symbol, int value, int value2, int type);
void PurgeLocalLabels(int index);
SymbolT *GetSymbolPointer(char *str);
int Evaluate(int precedence, int *pindex, char **tokens, int num);
int EvaluateExpression(int precedence, int *pindex, char **tokens, int num, int *pval);
